﻿------------------------------------------------------------------------------
-- $Id$
------------------------------------------------------------------------------
--                           module_demonology.lua
--
--	Copyright (C) 2012 Maighurl
--
--  This file is for use with clcInfo by abija.  Some of the code was pulled
--  from existing clcInfo modules and the example module.
--
--  abija has distributed clcInfo All Rights Reserved.  For more information
--  go to: http://wow.curseforge.com/addons/clctracker/
--
------------------------------------------------------------------------------
-- Author:
--      Maighurl
------------------------------------------------------------------------------
-- Description:
--   Actions module for demonology warlocks
------------------------------------------------------------------------------
if not clcInfo then return end       -- need clcInfo to run
if not clcInfo_Warlock then return end -- need clcInfo_Warlock
local _, englishClass = UnitClass("player") -- need to be a Warlock
if englishClass ~= clcInfo_Warlock.CLASS then return end

-- Get local copies of functions/tables.  This will speed up execution.
local clcInfo_Warlock = clcInfo_Warlock
local spells = clcInfo_Warlock.spells
local GetTimeLeft = clcInfo_Warlock.GetTimeLeft
local GetCooldown = clcInfo_Warlock.GetCooldown
local IconNext = clcInfo_Warlock.IconNext
local IconCurrent = clcInfo_Warlock.IconCurrent
local CLIP_HARMFUL = clcInfo_Warlock.CLIP_HARMFUL
local UnitPower = UnitPower

-- Assign module variables
local specname = "demonology"
local prio_arg = "demonologyprio"
local sample_prio = ""
local priority = {}
local class_module
local class_module_name

local db_default = {
    char_var = false,
}
local db

local tdb_default = {
    version = clcInfo_Warlock.VERSION,
    priority = priority,
}
local tdb

-- actions ---------------------------------------------------------------------
-- local copies of spell names and ids to ugly up code but speed action
-- functions up
-- we want the action functions to run as quickly as possible


local actions = {

}

----FUNCTIONS-------------------------------------------------------------------
-- The following are called once or infrequently, so speed isn't an issue.

-- called whenever module options are loaded
local GetDB
local SetDB
local GetTDB
local SetTDB
local GetPriority
local SetPriority

--initialize module.
class_module, class_module_name = clcInfo_Warlock:init_module(specname)

--called when template updates.
function class_module:OnTemplatesUpdate()
    tdb, GetTDB, SetTDB, GetPriority, SetPriority
        = clcInfo_Warlock:OnTemplatesUpdate(class_module_name, actions,
                                            tdb_default, specname)
end

-- called each time clcInfo initializes
function class_module.OnInitialize()
    db, GetDB, SetDB = clcInfo_Warlock:OnInitialize(class_module_name,
                                                    db_default)
end

-- called when module options are opened
local function LoadDemonologyModule()
    local _, talent_tree_name = GetTalentTabInfo(2)
    clcInfo_Warlock.LoadModule(class_module_name, talent_tree_name, sample_prio,
                               actions, GetDB, SetDB, GetTDB, SetTDB,
                               GetPriority, SetPriority)
end
clcInfo.optionsCMLoaders[#(clcInfo.optionsCMLoaders) + 1] = LoadDemonologyModule

-- giving queue as command line
local function CmdDemonology(args)
    clcInfo_Warlock:CmdLine(tdb, args, actions, specname)
end

clcInfo.cmdList[prio_arg] = CmdDemonology

----ABILITY ICONS--------------------------------------------------------------
----Add these to the clcInfo.env (so they live with IconAura, etc.
local emod = clcInfo.env
function emod.IconDemonologyCurrent(...)
    return IconCurrent(actions, specname, tdb.rangePerSkill)
end
function emod.IconDemonologyNext(...)
    return IconNext()
end
